local AddOn, _DUF = ...

local function Deactivate(frame)
	frame:UnregisterAllEvents()
	frame:SetScript("OnUpdate", nil)
	frame:SetScript("OnEvent", nil)
	frame:Hide()
end

local function UnHook(unitframe)
	if not unitframe then return; end
	UnregisterUnitWatch(unitframe)		
	Deactivate(unitframe)
	-- Make it so it won't be visible, even if shown by another mod
	unitframe:Hide()
	unitframe:ClearAllPoints()
	unitframe:SetPoint("BOTTOMLEFT", UIParent, "TOPLEFT", -400, 500)
	local bar = _G[unitframe:GetName().."HealthBar"]
	if bar then
		Deactivate(bar)
	end
	bar = _G[unitframe:GetName().."ManaBar"]
	if bar then
		Deactivate(bar)
	end
	bar = _G[unitframe:GetName().."MultiGroupFrame"]
	if bar then
		Deactivate(bar)
	end
end

function _DUF:DUF_SetDefaultUIHooks()
	Deactivate(PlayerSpeakerFrame)
	UnHook(TargetofFocusFrame)
	UnHook(TargetFrameToT)
	
	if not DUF_Settings[DUF_INDEX].player.showDefault then
		UnHook(PlayerFrame)
		Deactivate(ComboPointPlayerFrame)
		Deactivate(InsanityBarFrame)
		Deactivate(MageArcaneChargesFrame)
		Deactivate(MonkHarmonyBarFrame)
		Deactivate(PaladinPowerBarFrame)
		Deactivate(WarlockPowerFrame)
		Deactivate(MonkStaggerBar)
		
	end
	if DUF_Settings[DUF_INDEX].hidedurability then 
		Deactivate(DurabilityFrame)
	end
	if not DUF_Settings[DUF_INDEX].focus.showDefault then
		UnHook(FocusFrame)
	end
	if not DUF_Settings[DUF_INDEX].targettarget.showDefault then
		UnHook(TargetofTargetFrame)
	end
	if not DUF_Settings[DUF_INDEX].target.showDefault then
		UnHook(TargetFrame)
	end
	if not DUF_Settings[DUF_INDEX].pet.showDefault then
		UnHook(PetFrame)
		Deactivate(PetCastingBarFrame)
	end
	if not DUF_Settings[DUF_INDEX].party.showDefault then
		for i = 1, 4 do
			UnHook(_G["PartyMemberFrame"..i])
		end
	end
	if not DUF_Settings[DUF_INDEX].partypet.showDefault then
		for i = 1, 4 do
			UnHook(_G["PartyMemberFrame"..i.."PetFrame"])
		end
	end
	if not DUF_Settings[DUF_INDEX].boss.showDefault then
		for i = 1, 5 do
			UnHook(_G["Boss"..i.."TargetFrame"])
		end
	end
end
