local AddOn, _DUF = ...

local settings

local function MoveTotem(self)
	if not settings then return end
	_DUF:DUF_Set_ElementPosition(TotemFrame, DUF_FRAME_DATA["player"].frame, settings)
--	TotemFrame:ClearAllPoints()
--	TotemFrame:SetPoint(settings.attachpoint, settings.attach, settings.attachto, settings.xoffset, settings.yoffset)
	if settings.hide then
		TotemFrame:SetPoint("RIGHT", UIParent, "LEFT", -100)
		return
	end
end

local function CreateOverlay(totem, index)
	local f = CreateFrame("Frame", "DUF_TotemFrame_Overlay_"..index)
	f:SetAllPoints(totem)
	f.Texture = f:CreateTexture("$parentTexture", "OVERLAY")
	f.Texture:SetAllPoints()
	f.Texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Buff")
	return f
end

function DUF_Initialize_TotemFrame(config)
	if TotemFrame:GetParent() ~= UIParent then
		TotemFrame:SetParent(UIParent)
	end
	local t = _G["TotemFrameTotem1Background"]
	settings = DUF_Settings[DUF_INDEX].player.TotemFrame
	local point, toPoint, spacingX, spacingY = _DUF:DUF_Get_Direction(settings)
	for i = 1, MAX_TOTEMS do
		local totem = _G["TotemFrameTotem"..i]
		totem:ClearAllPoints()
		if i == 1 then
			totem:SetPoint(point, TotemFrame, 0, 0)
		else
			totem:SetPoint(point, _G["TotemFrameTotem"..i-1], toPoint, spacingX, spacingY)
		end
		totem.duration:ClearAllPoints()
		totem.duration:SetPoint("TOP", totem, "BOTTOM", 0, -0.5)
		if settings.scale then
			totem:SetScale(settings.scale)
		end
		local f = _G["DUF_TotemFrame_Overlay_"..i]
		if config then
			if not f then
				f = CreateOverlay(totem, i)
			end
			f:Show()
		else
			if f then
				f:Hide()
			end
		end
	end
	hooksecurefunc("TotemFrame_Update", MoveTotem)
	MoveTotem()
end
